// Datei: Phaserec.c
// Bi-Phasen RC5 Empfnger
// 1-Kanal Empfnger mit 16 einstellbaren Codes
//
// hk@holger-klabunde.de
// www.holger-klabunde.de
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      // Der verwendete Prozessor

#include "Phaserec.h"
#include "protos.h"

#include "phase.c"

unsigned char shift;   //Register fr die Abtastung
unsigned char subcode; //Der RC5 Gertecode
unsigned char keycode; //Der mit den Jumpern eingestellte Commandocode
unsigned char comcode; //Der empfangene RC5 Kommandocode
unsigned char combuf;  //Puffer fr Kommandocode. Fr Verify
unsigned char subbuf;
unsigned char toggle;  //Das Togglebit

//*******************************************************
// Hauptprogramm
//*******************************************************
void main()
{ 
 unsigned char by,buf;

 OSCCAL=W; //Als erstes den Kalibrierwert fr den int. RC-Oszi sichern

 CLRWDT;	    //Vor ndern des Prescalers auf Timer0 laut Microchip

 OPTION=0b11000010; //Kein Wake up on pin change, Pullups disabled, Timer0 int. Source
                       //Prescaler 1:8
                       
//Ein TimerClock = 1us * 8 = 8us
 
 TRIS=0b111011; 	//0=Ausgang, 1=Eingang

 GPIO=0b111011;  //Port einmal schreiben

 shift=0; //Empfangsregister lschen
 
 while(1) // Programm-Endlosschleife
  {

   do
    {
     by=PhaseDemod(); //Warten auf eingehende Impulse
    }while(by==0);

   combuf=comcode; //Eben empfangenen Code speichern
   subbuf=subcode;

   do //Code ein zweites mal empfangen
    {
     by=PhaseDemod(); //Warten auf eingehende Impulse
    }while(by==0);


   if(comcode==combuf && subcode==subbuf) //Beide Codes gleich ?
    {
     by=GPIO; //Eingnge lesen

     keycode=by&0x03; //Jumper Commandocode an GP0,1
     buf=by&0x30;     //Die Jumper an GP4,5
     buf>>=2;              //Zwei Bit nach rechts schieben
     keycode+=buf;         //In Commandocode einfgen
   			   
     if(subcode==SUBID) //Empfnger ID ok ??
      {
       if(comcode==keycode) //Kommandocode ok ?
        {
         if(toggle==ONE) { LED_ON(); }  //Je nach ToggleBit an oder aus
         else { LED_OFF(); }
        }

      }

    } //if(comcode==combuf && subcode==subbuf)
   
  } //while(1) Endlosschleife

}
